// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marker_msgs:msg/Fiducial.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__FIDUCIAL__STRUCT_H_
#define MARKER_MSGS__MSG__DETAIL__FIDUCIAL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'ids'
// Member 'ids_confidence'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'object_points'
// Member 'image_points'
#include "geometry_msgs/msg/detail/point__struct.h"

/// Struct defined in msg/Fiducial in the package marker_msgs.
/**
  * This expresses a known detected fiducial in image space
 */
typedef struct marker_msgs__msg__Fiducial
{
  /// possible ids of the detected fiducial (empty if no id could be identified)
  rosidl_runtime_c__int32__Sequence ids;
  /// confidence of the possible ids in [0, 1]
  rosidl_runtime_c__double__Sequence ids_confidence;
  /// Array of object points in the object coordinate space.
  geometry_msgs__msg__Point__Sequence object_points;
  /// Array of corresponding image points. Point.z is not used.
  geometry_msgs__msg__Point__Sequence image_points;
} marker_msgs__msg__Fiducial;

// Struct for a sequence of marker_msgs__msg__Fiducial.
typedef struct marker_msgs__msg__Fiducial__Sequence
{
  marker_msgs__msg__Fiducial * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} marker_msgs__msg__Fiducial__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MARKER_MSGS__MSG__DETAIL__FIDUCIAL__STRUCT_H_
