// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marker_msgs:msg/FiducialDetection.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__FIDUCIAL_DETECTION__STRUCT_H_
#define MARKER_MSGS__MSG__DETAIL__FIDUCIAL_DETECTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'camera_d'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'type'
#include "rosidl_runtime_c/string.h"
// Member 'fiducial'
#include "marker_msgs/msg/detail/fiducial__struct.h"

/// Struct defined in msg/FiducialDetection in the package marker_msgs.
/**
  * This expresses a marker/fiducial detection
 */
typedef struct marker_msgs__msg__FiducialDetection
{
  /// timestamp in the header is the acquisition time and frame
  std_msgs__msg__Header header;
  /// The distortion parameters, size depending on the distortion model.
  /// For "plumb_bob", the 5 parameters are: (k1, k2, t1, t2, k3).
  rosidl_runtime_c__double__Sequence camera_d;
  /// Intrinsic camera matrix for the raw (distorted) images.
  ///     [fx  0 cx]
  /// K = [ 0 fy cy]
  ///     [ 0  0  1]
  /// Projects 3D points in the camera coordinate frame to 2D pixel
  /// coordinates using the focal lengths (fx, fy) and principal point
  /// (cx, cy).
  /// 3x3 row-major matrix
  double camera_k[9];
  /// marker type used (bch, artag, mip_36h12, stage, ...)
  rosidl_runtime_c__String type;
  /// detected markers
  marker_msgs__msg__Fiducial__Sequence fiducial;
} marker_msgs__msg__FiducialDetection;

// Struct for a sequence of marker_msgs__msg__FiducialDetection.
typedef struct marker_msgs__msg__FiducialDetection__Sequence
{
  marker_msgs__msg__FiducialDetection * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} marker_msgs__msg__FiducialDetection__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MARKER_MSGS__MSG__DETAIL__FIDUCIAL_DETECTION__STRUCT_H_
