// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marker_msgs:msg/FiducialDetection.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__FIDUCIAL_DETECTION__TRAITS_HPP_
#define MARKER_MSGS__MSG__DETAIL__FIDUCIAL_DETECTION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "marker_msgs/msg/detail/fiducial_detection__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'fiducial'
#include "marker_msgs/msg/detail/fiducial__traits.hpp"

namespace marker_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const FiducialDetection & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: camera_d
  {
    if (msg.camera_d.size() == 0) {
      out << "camera_d: []";
    } else {
      out << "camera_d: [";
      size_t pending_items = msg.camera_d.size();
      for (auto item : msg.camera_d) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: camera_k
  {
    if (msg.camera_k.size() == 0) {
      out << "camera_k: []";
    } else {
      out << "camera_k: [";
      size_t pending_items = msg.camera_k.size();
      for (auto item : msg.camera_k) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: fiducial
  {
    if (msg.fiducial.size() == 0) {
      out << "fiducial: []";
    } else {
      out << "fiducial: [";
      size_t pending_items = msg.fiducial.size();
      for (auto item : msg.fiducial) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FiducialDetection & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: camera_d
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.camera_d.size() == 0) {
      out << "camera_d: []\n";
    } else {
      out << "camera_d:\n";
      for (auto item : msg.camera_d) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: camera_k
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.camera_k.size() == 0) {
      out << "camera_k: []\n";
    } else {
      out << "camera_k:\n";
      for (auto item : msg.camera_k) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: fiducial
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.fiducial.size() == 0) {
      out << "fiducial: []\n";
    } else {
      out << "fiducial:\n";
      for (auto item : msg.fiducial) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FiducialDetection & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace marker_msgs

namespace rosidl_generator_traits
{

[[deprecated("use marker_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const marker_msgs::msg::FiducialDetection & msg,
  std::ostream & out, size_t indentation = 0)
{
  marker_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use marker_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const marker_msgs::msg::FiducialDetection & msg)
{
  return marker_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<marker_msgs::msg::FiducialDetection>()
{
  return "marker_msgs::msg::FiducialDetection";
}

template<>
inline const char * name<marker_msgs::msg::FiducialDetection>()
{
  return "marker_msgs/msg/FiducialDetection";
}

template<>
struct has_fixed_size<marker_msgs::msg::FiducialDetection>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marker_msgs::msg::FiducialDetection>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marker_msgs::msg::FiducialDetection>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARKER_MSGS__MSG__DETAIL__FIDUCIAL_DETECTION__TRAITS_HPP_
