// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from marker_msgs:msg/FiducialDetection.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "marker_msgs/msg/detail/fiducial_detection__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace marker_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void FiducialDetection_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) marker_msgs::msg::FiducialDetection(_init);
}

void FiducialDetection_fini_function(void * message_memory)
{
  auto typed_message = static_cast<marker_msgs::msg::FiducialDetection *>(message_memory);
  typed_message->~FiducialDetection();
}

size_t size_function__FiducialDetection__camera_d(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<double> *>(untyped_member);
  return member->size();
}

const void * get_const_function__FiducialDetection__camera_d(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<double> *>(untyped_member);
  return &member[index];
}

void * get_function__FiducialDetection__camera_d(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<double> *>(untyped_member);
  return &member[index];
}

void fetch_function__FiducialDetection__camera_d(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const double *>(
    get_const_function__FiducialDetection__camera_d(untyped_member, index));
  auto & value = *reinterpret_cast<double *>(untyped_value);
  value = item;
}

void assign_function__FiducialDetection__camera_d(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<double *>(
    get_function__FiducialDetection__camera_d(untyped_member, index));
  const auto & value = *reinterpret_cast<const double *>(untyped_value);
  item = value;
}

void resize_function__FiducialDetection__camera_d(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<double> *>(untyped_member);
  member->resize(size);
}

size_t size_function__FiducialDetection__camera_k(const void * untyped_member)
{
  (void)untyped_member;
  return 9;
}

const void * get_const_function__FiducialDetection__camera_k(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::array<double, 9> *>(untyped_member);
  return &member[index];
}

void * get_function__FiducialDetection__camera_k(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::array<double, 9> *>(untyped_member);
  return &member[index];
}

void fetch_function__FiducialDetection__camera_k(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const double *>(
    get_const_function__FiducialDetection__camera_k(untyped_member, index));
  auto & value = *reinterpret_cast<double *>(untyped_value);
  value = item;
}

void assign_function__FiducialDetection__camera_k(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<double *>(
    get_function__FiducialDetection__camera_k(untyped_member, index));
  const auto & value = *reinterpret_cast<const double *>(untyped_value);
  item = value;
}

size_t size_function__FiducialDetection__fiducial(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<marker_msgs::msg::Fiducial> *>(untyped_member);
  return member->size();
}

const void * get_const_function__FiducialDetection__fiducial(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<marker_msgs::msg::Fiducial> *>(untyped_member);
  return &member[index];
}

void * get_function__FiducialDetection__fiducial(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<marker_msgs::msg::Fiducial> *>(untyped_member);
  return &member[index];
}

void fetch_function__FiducialDetection__fiducial(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const marker_msgs::msg::Fiducial *>(
    get_const_function__FiducialDetection__fiducial(untyped_member, index));
  auto & value = *reinterpret_cast<marker_msgs::msg::Fiducial *>(untyped_value);
  value = item;
}

void assign_function__FiducialDetection__fiducial(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<marker_msgs::msg::Fiducial *>(
    get_function__FiducialDetection__fiducial(untyped_member, index));
  const auto & value = *reinterpret_cast<const marker_msgs::msg::Fiducial *>(untyped_value);
  item = value;
}

void resize_function__FiducialDetection__fiducial(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<marker_msgs::msg::Fiducial> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember FiducialDetection_message_member_array[5] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marker_msgs::msg::FiducialDetection, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "camera_d",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marker_msgs::msg::FiducialDetection, camera_d),  // bytes offset in struct
    nullptr,  // default value
    size_function__FiducialDetection__camera_d,  // size() function pointer
    get_const_function__FiducialDetection__camera_d,  // get_const(index) function pointer
    get_function__FiducialDetection__camera_d,  // get(index) function pointer
    fetch_function__FiducialDetection__camera_d,  // fetch(index, &value) function pointer
    assign_function__FiducialDetection__camera_d,  // assign(index, value) function pointer
    resize_function__FiducialDetection__camera_d  // resize(index) function pointer
  },
  {
    "camera_k",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    9,  // array size
    false,  // is upper bound
    offsetof(marker_msgs::msg::FiducialDetection, camera_k),  // bytes offset in struct
    nullptr,  // default value
    size_function__FiducialDetection__camera_k,  // size() function pointer
    get_const_function__FiducialDetection__camera_k,  // get_const(index) function pointer
    get_function__FiducialDetection__camera_k,  // get(index) function pointer
    fetch_function__FiducialDetection__camera_k,  // fetch(index, &value) function pointer
    assign_function__FiducialDetection__camera_k,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "type",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marker_msgs::msg::FiducialDetection, type),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "fiducial",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<marker_msgs::msg::Fiducial>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marker_msgs::msg::FiducialDetection, fiducial),  // bytes offset in struct
    nullptr,  // default value
    size_function__FiducialDetection__fiducial,  // size() function pointer
    get_const_function__FiducialDetection__fiducial,  // get_const(index) function pointer
    get_function__FiducialDetection__fiducial,  // get(index) function pointer
    fetch_function__FiducialDetection__fiducial,  // fetch(index, &value) function pointer
    assign_function__FiducialDetection__fiducial,  // assign(index, value) function pointer
    resize_function__FiducialDetection__fiducial  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers FiducialDetection_message_members = {
  "marker_msgs::msg",  // message namespace
  "FiducialDetection",  // message name
  5,  // number of fields
  sizeof(marker_msgs::msg::FiducialDetection),
  FiducialDetection_message_member_array,  // message members
  FiducialDetection_init_function,  // function to initialize message memory (memory has to be allocated)
  FiducialDetection_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t FiducialDetection_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &FiducialDetection_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace marker_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<marker_msgs::msg::FiducialDetection>()
{
  return &::marker_msgs::msg::rosidl_typesupport_introspection_cpp::FiducialDetection_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, marker_msgs, msg, FiducialDetection)() {
  return &::marker_msgs::msg::rosidl_typesupport_introspection_cpp::FiducialDetection_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
