// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marker_msgs:msg/Fiducial.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__FIDUCIAL__TRAITS_HPP_
#define MARKER_MSGS__MSG__DETAIL__FIDUCIAL__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "marker_msgs/msg/detail/fiducial__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'object_points'
// Member 'image_points'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace marker_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Fiducial & msg,
  std::ostream & out)
{
  out << "{";
  // member: ids
  {
    if (msg.ids.size() == 0) {
      out << "ids: []";
    } else {
      out << "ids: [";
      size_t pending_items = msg.ids.size();
      for (auto item : msg.ids) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: ids_confidence
  {
    if (msg.ids_confidence.size() == 0) {
      out << "ids_confidence: []";
    } else {
      out << "ids_confidence: [";
      size_t pending_items = msg.ids_confidence.size();
      for (auto item : msg.ids_confidence) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: object_points
  {
    if (msg.object_points.size() == 0) {
      out << "object_points: []";
    } else {
      out << "object_points: [";
      size_t pending_items = msg.object_points.size();
      for (auto item : msg.object_points) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: image_points
  {
    if (msg.image_points.size() == 0) {
      out << "image_points: []";
    } else {
      out << "image_points: [";
      size_t pending_items = msg.image_points.size();
      for (auto item : msg.image_points) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Fiducial & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ids.size() == 0) {
      out << "ids: []\n";
    } else {
      out << "ids:\n";
      for (auto item : msg.ids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: ids_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ids_confidence.size() == 0) {
      out << "ids_confidence: []\n";
    } else {
      out << "ids_confidence:\n";
      for (auto item : msg.ids_confidence) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: object_points
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.object_points.size() == 0) {
      out << "object_points: []\n";
    } else {
      out << "object_points:\n";
      for (auto item : msg.object_points) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: image_points
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.image_points.size() == 0) {
      out << "image_points: []\n";
    } else {
      out << "image_points:\n";
      for (auto item : msg.image_points) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Fiducial & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace marker_msgs

namespace rosidl_generator_traits
{

[[deprecated("use marker_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const marker_msgs::msg::Fiducial & msg,
  std::ostream & out, size_t indentation = 0)
{
  marker_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use marker_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const marker_msgs::msg::Fiducial & msg)
{
  return marker_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<marker_msgs::msg::Fiducial>()
{
  return "marker_msgs::msg::Fiducial";
}

template<>
inline const char * name<marker_msgs::msg::Fiducial>()
{
  return "marker_msgs/msg/Fiducial";
}

template<>
struct has_fixed_size<marker_msgs::msg::Fiducial>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marker_msgs::msg::Fiducial>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marker_msgs::msg::Fiducial>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARKER_MSGS__MSG__DETAIL__FIDUCIAL__TRAITS_HPP_
