// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from marker_msgs:msg/MarkerDetection.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__MARKER_DETECTION__STRUCT_HPP_
#define MARKER_MSGS__MSG__DETAIL__MARKER_DETECTION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'view_direction'
#include "geometry_msgs/msg/detail/quaternion__struct.hpp"
// Member 'markers'
#include "marker_msgs/msg/detail/marker__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__marker_msgs__msg__MarkerDetection __attribute__((deprecated))
#else
# define DEPRECATED__marker_msgs__msg__MarkerDetection __declspec(deprecated)
#endif

namespace marker_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MarkerDetection_
{
  using Type = MarkerDetection_<ContainerAllocator>;

  explicit MarkerDetection_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    view_direction(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->distance_min = 0.0f;
      this->distance_max = 0.0f;
      this->distance_max_id = 0.0f;
      this->fov_horizontal = 0.0f;
      this->fov_vertical = 0.0f;
      this->type = "";
    }
  }

  explicit MarkerDetection_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    view_direction(_alloc, _init),
    type(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->distance_min = 0.0f;
      this->distance_max = 0.0f;
      this->distance_max_id = 0.0f;
      this->fov_horizontal = 0.0f;
      this->fov_vertical = 0.0f;
      this->type = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _distance_min_type =
    float;
  _distance_min_type distance_min;
  using _distance_max_type =
    float;
  _distance_max_type distance_max;
  using _distance_max_id_type =
    float;
  _distance_max_id_type distance_max_id;
  using _view_direction_type =
    geometry_msgs::msg::Quaternion_<ContainerAllocator>;
  _view_direction_type view_direction;
  using _fov_horizontal_type =
    float;
  _fov_horizontal_type fov_horizontal;
  using _fov_vertical_type =
    float;
  _fov_vertical_type fov_vertical;
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _type_type type;
  using _markers_type =
    std::vector<marker_msgs::msg::Marker_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<marker_msgs::msg::Marker_<ContainerAllocator>>>;
  _markers_type markers;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__distance_min(
    const float & _arg)
  {
    this->distance_min = _arg;
    return *this;
  }
  Type & set__distance_max(
    const float & _arg)
  {
    this->distance_max = _arg;
    return *this;
  }
  Type & set__distance_max_id(
    const float & _arg)
  {
    this->distance_max_id = _arg;
    return *this;
  }
  Type & set__view_direction(
    const geometry_msgs::msg::Quaternion_<ContainerAllocator> & _arg)
  {
    this->view_direction = _arg;
    return *this;
  }
  Type & set__fov_horizontal(
    const float & _arg)
  {
    this->fov_horizontal = _arg;
    return *this;
  }
  Type & set__fov_vertical(
    const float & _arg)
  {
    this->fov_vertical = _arg;
    return *this;
  }
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__markers(
    const std::vector<marker_msgs::msg::Marker_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<marker_msgs::msg::Marker_<ContainerAllocator>>> & _arg)
  {
    this->markers = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    marker_msgs::msg::MarkerDetection_<ContainerAllocator> *;
  using ConstRawPtr =
    const marker_msgs::msg::MarkerDetection_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<marker_msgs::msg::MarkerDetection_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<marker_msgs::msg::MarkerDetection_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      marker_msgs::msg::MarkerDetection_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<marker_msgs::msg::MarkerDetection_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      marker_msgs::msg::MarkerDetection_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<marker_msgs::msg::MarkerDetection_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<marker_msgs::msg::MarkerDetection_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<marker_msgs::msg::MarkerDetection_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__marker_msgs__msg__MarkerDetection
    std::shared_ptr<marker_msgs::msg::MarkerDetection_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__marker_msgs__msg__MarkerDetection
    std::shared_ptr<marker_msgs::msg::MarkerDetection_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MarkerDetection_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->distance_min != other.distance_min) {
      return false;
    }
    if (this->distance_max != other.distance_max) {
      return false;
    }
    if (this->distance_max_id != other.distance_max_id) {
      return false;
    }
    if (this->view_direction != other.view_direction) {
      return false;
    }
    if (this->fov_horizontal != other.fov_horizontal) {
      return false;
    }
    if (this->fov_vertical != other.fov_vertical) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->markers != other.markers) {
      return false;
    }
    return true;
  }
  bool operator!=(const MarkerDetection_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MarkerDetection_

// alias to use template instance with default allocator
using MarkerDetection =
  marker_msgs::msg::MarkerDetection_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace marker_msgs

#endif  // MARKER_MSGS__MSG__DETAIL__MARKER_DETECTION__STRUCT_HPP_
